pp <- read.table("c:/articles/reasoning/dube/r-scripts/confi.dat")
# Path will have to be adapted to point to the directory in which
# the file confi.dat is located
e<-c(rep(0,24))
NN<-c(rep(0,4))
#Experiment 1
d<-pp[1:24,1]
# Experiment 2
#d<-pp[25:48,1]
# Experiment 3; analysis by believability
#d<-pp[49:72,1]
for (i in 1:4) NN[i]<-sum(d[(6*(i-1)+1):(6*i)])
d
NN

# function p generates a probability distribution over end-start+2 points from end-start+1 non-negative real numbers
# stored in array x between positions start and end and returns the probability for category number "ind"


# Making a probability distribution for n categories from n-1
#nonnegative real numbers

pmake<- function(x,m) {
 temp <- c(x,1.0)
 xsum<-sum(temp[1:m])
 temp<-temp/xsum
temp
#print(xsum)
}
 

##Q1-4: rvb, rib,ivu,riu
##Q5-9: 5 non-negative numbers generating bias parameters ab
##Q10-14: 5 non-negative numbers generating bias parameters au
##Q15-16: 2 non-negative numbers generating sh,sm, and sl

####Multinomial model
g<-function(Q){ 
rvb <- Q[1]
rib <- Q[2]
rvu <- Q[3]
riu <- Q[4]
#rvu<-rvb;riu<-rib
#rrib<-0; riu<-0
#rvb<-0; rvu<-0

ab<-pmake(Q[5:9],6)
au<-pmake(Q[10:14],6)

s <- pmake(Q[15:16],3)
sh<-s[1]
sm<-s[2]
sl<-s[3]

e<-c(rep(0,24))
e[1]<-  rvb*sh
e[2]<-  rvb*sm
e[3]<-  rvb*sl
for (i in 1:6) e[i]<-NN[1]*(e[i]+(1-rvb)*ab[i])

e[10]<- rib*sl
e[11]<- rib*sm                            
e[12]<- rib*sh                    
for (i in 7:12) e[i]<-NN[2]*(e[i]+(1-rib)*ab[i-6])

e[13]<-  rvu*sh
e[14]<-  rvu*sm
e[15]<-  rvu*sl
for (i in 13:18) e[i]<-NN[3]*(e[i]+(1-rvu)*au[i-12])

e[22]<- riu*sl
e[23]<- riu*sm                            
e[24]<- riu*sh                    
for (i in 19:24) e[i]<-NN[4]*(e[i]+(1-riu)*au[i-18])

tempsum<-0
for (i in 1:24) {
 if (d[i]==0) t<-0.0
 else t<- 2* d[i]*(log(d[i])-log(e[i]))
 tempsum<-tempsum+t
# print(e)
}
tempsum
}
store<-Inf
for (i in 1:10) {
Gtest<-nlminb(runif(16),g,control = list(eval.max=1500,iter.max=1500),lower=c(rep(0,16)),upper=c(rep(1,4),rep(Inf,12)))
 if (Gtest$objective < store) {store<-Gtest$objective; st<-Gtest}
}
st
# r Parameters are the first four parameters printed out here
# in order, rvb, rib, rvu, riu

pmake(st$par[5:9],6)
# These are the ab parameters for categories 1 to 6

pmake(st$par[10:14],6)
# These are the au parameters for categories 1 to 6

pmake(st$par[15:16],3)
# These are the s parameters sh, sm, sl



#############
#Experiment 3:  3 Groups; analysis by base rate

d<-pp[73:108,1]
NN<-c(rep(0,6))
for (i in 1:6) NN[i]<-sum(d[(6*(i-1)+1):(6*i)])
d
NN

####Multinomial Model
g2<-function(Q){ 
rv1 <- Q[1]
ri1 <- Q[2]
rv2 <- Q[3]
ri2 <- Q[4]
rv3 <- Q[5]
ri3 <-Q[6]
#rv2<-rv1;rv3<-rv1;ri2<-ri1;ri3<-ri1
#ri1<-0; ri2<-0; ri3<-0
#rv1<-0; rv2<-0; rv3<-0
a1<-pmake(Q[7:11],6)
a2<-pmake(Q[12:16],6)
a3<-pmake(Q[17:21],6)

s<- pmake(Q[22:23],3)
s1<-s[1]
s2<-s[2]
s3<-s[3]

e<-c(rep(0,36))
e[1]<-  rv1*s1
e[2]<-  rv1*s2
e[3]<-  rv1*s3
for (i in 1:6) e[i]<-NN[1]*(e[i]+(1-rv1)*a1[i])

e[10]<- ri1*s3
e[11]<- ri1*s2                            
e[12]<- ri1*s1                    
for (i in 7:12) e[i]<-NN[2]*(e[i]+(1-ri1)*a1[i-6])

e[13]<-  rv2*s1
e[14]<-  rv2*s2
e[15]<-  rv2*s3
for (i in 13:18) e[i]<-NN[3]*(e[i]+(1-rv2)*a2[i-12])

e[22]<- ri2*s3
e[23]<- ri2*s2                            
e[24]<- ri2*s1                    
for (i in 19:24) e[i]<-NN[4]*(e[i]+(1-ri2)*a2[i-18])

e[25]<-  rv3*s1
e[26]<-  rv3*s2
e[27]<-  rv3*s3
for (i in 25:30) e[i]<-NN[5]*(e[i]+(1-rv3)*a3[i-24])

e[34]<- ri3*s3
e[35]<- ri3*s2                            
e[36]<- ri3*s1                    
for (i in 31:36) e[i]<-NN[6]*(e[i]+(1-ri3)*a3[i-30])


tempsum<-0
for (i in 1:36) {
 if (d[i]==0) t<-0.0
 else t<- 2* d[i]*(log(d[i])-log(e[i]))
 tempsum<-tempsum+t
# print(e)
}
tempsum
}
store<-Inf
for (i in 1:10) {
Gtest<-nlminb(runif(23),g2,control = list(eval.max=1500,iter.max=1500),lower=c(rep(0,23)),upper=c(rep(1,6),rep(Inf,17)))
 if (Gtest$objective < store) {store<-Gtest$objective; st<-Gtest}
}
st

# r Parameters are the first six parameters printed out here
# in order, rv1, ri1, rv2, ri2, rv3, ri3

pmake(st$par[7:11],6)
# These are the a1 parameters for categories 1 to 6

pmake(st$par[12:16],6)
# These are the a2 parameters for categories 1 to 6

pmake(st$par[17:21],6)
# These are the a3 parameters for categories 1 to 6



pmake(st$par[22:23],3)
# These are the s parameters sh, sm, sl


